﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace TestProject
{
    //  テスト・クラスにには、TestClass属性を付加します。
    [TestClass]
    public class CalculatorUnitTest
    {
        private Calculator calculator;

        //  テスト・メソッド前の初期化コードには、TestInitialize属性を付加します。
        [TestInitialize]
        public void Initialize() 
        {
            calculator = new Calculator();
        }

        //  テスト・メソッドには、TestMethod属性を付加します。
        [TestMethod]
        public void TestNormalAdd()
        {
            //  1 + 1の結果が2かどうかをテスト。
            Assert.AreEqual(2, calculator.Add(1, 1));
        }

        //  例外が発生することをテストするには、ExpectedException属性を付加します。
        [ExpectedException(typeof(OverflowException))]
        [TestMethod]
        public void TestOverflowAdd()
        {
            //  int型なので、オーバー・フローが発生するかをテスト。
            calculator.Add(Int32.MaxValue, 1);
        }
    }
}
